Uses Crt, Dos;
Type
  HeaderData = Record
    ID : Array[1..8] Of Char;
    UnKnow1 : Word;
    Folder : Array[1..8] Of Char;
    Comment : Array[1..40] Of Char;
    UnKnow2 : Word;
    UnKnow3 : LongInt;
    Name : Array[1..8] Of Char;
    UnKnow4 : LongInt;
    FileSize : LongInt;
    UnKnow5 : LongInt;
    DataSize : Array[1..4] of Byte;
  End;

Var
  F, G : File; {F -> Fichier existant, G -> Fichier a creer}
  Head : HeaderData;
  I : Word;
  Data : Byte;
  CheckSum : Word;
  DataByte : LongInt;
  Folder, FileName : String;
  FileType : Word;
  Error : Integer;

Begin
  ClrScr;
  WriteLn('DataMaker V1.0 by Philippe Gervaise aKa CandyMan');
  If ParamCount <> 3 Then
  Begin
    WriteLn;
    WriteLn('MakeData <Input> <OutPut> <Folder>');
    WriteLn('  <Input>    : Data File');
    WriteLn('  <Output>   : Export file (with extension)');
    WriteLn('  <Folder>   : Folder where the file would be (8 char max)');
    Halt;
  End;

  Head.ID := '**TI89**';
  Head.UnKnow1 := 1;
  Head.Folder := 'main' + Chr(0) + '   ';
  Folder := ParamStr(3);
  For I := 1 To 8 Do
    If I <= Length(Folder) Then Head.Folder[I] := Folder[I] Else
      Head.Folder[I] := Chr(0);

  For I := 1 To 40 Do
    Head.Comment[I] := Chr(0);
  Head.UnKnow2 := 1;
  Head.UnKnow3 := 82;
  Head.UnKnow4 := 12;
  Head.FileSize := 0; {Pour apres}
  Head.UnKnow5 := 23205;
  Head.DataSize[1] := 0;
  Head.DataSize[2] := 0;
  Head.DataSize[3] := 0;
  Head.DataSize[4] := 0;

  If Pos('.', ParamStr(2)) <> 0 Then
    FileName := Copy(ParamStr(2), 1, Pos('.', ParamStr(2)) - 1);

  If Length(FileName) > 8 Then
    FileName := Copy(FileName, Length(FileName) - 7, 8);

  If (Pos(':', FileName) <> 0) Then
    FileName := Copy(FileName, Pos(':', FileName) + 1, 255);

  If (Pos('\', FileName) <> 0) Then
    FileName := Copy(FileName, Pos('\', FileName) + 1, 255);


  For I := 1 To 8 Do
    If I <= Length(FileName) Then Head.Name[I] := FileName[I] Else
      Head.Name[I] := Chr(0);

  Assign(F, Paramstr(1));
  Assign(G, Paramstr(2));
  {$I-}
  Reset(F, 1);
  If IoResult <> 0 Then
  Begin
    WriteLn('File ', Paramstr(1), ' does not exist !');
    Halt;
  End;
  {$I+}
  Rewrite(G, 1);
  BlockWrite(G, Head, SizeOf(HeaderData));

  For I := 1 To FileSize(F) Do
  Begin
    BlockRead(F, Data, 1);
    BlockWrite(G, Data, 1);
  End;

  Val(ParamStr(4), FileType, Error);

  Seek(G, 0);
  Head.DataSize[3] := (FileSize(G) - SizeOf(HeaderData)) Shr 8;
  Head.DataSize[4] := (FileSize(G) - SizeOf(HeaderData)) And 255;
  BlockWrite(G, Head, SizeOf(HeaderData));

  {Calcule le checksum}
  CheckSum := 0;
  Seek(G, 86);
  For I := 86 To FileSize(G) - 1 Do
  Begin
    BlockRead(G, Data, 1);
    Inc(CheckSum, Data);
  End;

  Seek(G, FileSize(G));
  Data := CheckSum And 255;
  BlockWrite(G, Data, 1);
  Data := CheckSum Shr 8;
  BlockWrite(G, Data, 1);

  Head.FileSize := FileSize(G);
  Seek(G, 0);
  BlockWrite(G, Head, SizeOf(HeaderData));

  Close(G);
  Close(F);
End.